import { world, system, ItemStack, EquipmentSlot, EntityComponentTypes, ItemCooldownComponent } from "@minecraft/server"

const globalscoreboard = world.scoreboard

// Import Subcores
import "./subcores/weapons.js"
import "./subcores/entities.js"
import "./subcores/lore.js"
import "./subcores/guidebook.js"

// Detect Sneaking
system.runInterval(() => {
    for (const player of world.getAllPlayers()) {
        if (player.isSneaking) {
            player.addTag('darkw_dotvi:is_sneaking');
        }
        else if (!player.isSneaking) {
            player.removeTag('darkw_dotvi:is_sneaking');
        }
    }
})

system.afterEvents.scriptEventReceive.subscribe(event => {
    switch (event.id) {
        case "darkw_dotvi:on_death_adjust": {
            const source = event.sourceEntity
            source.clearVelocity()
            break
        }
        case "darkw_dotvi:deathblade_sword_victim": {
            const victim = event.sourceEntity
            victim.setOnFire(5)
            victim.addEffect('wither', 100, { amplifier: 5 })
            break
        }

    }
})

