import { world, system, ItemStack, EquipmentSlot, EntityComponentTypes, ItemCooldownComponent } from "@minecraft/server"

world.afterEvents.entityHurt.subscribe(event => {
    const a = event.damageSource.damagingEntity
    const b = event.hurtEntity

    if (!a) return
    if (!b) return

    // Deathblade
    if (a.typeId === 'darkw_dotvi:deathblade') {
        const deathblade = event.damageSource.damagingEntity
        const player = event.hurtEntity
        const ShieldTest = player.runCommand('/testfor @s[hasitem={item=minecraft:shield, location=slot.weapon.offhand}]').successCount

        // Get current attack state
        const attackstate = deathblade.getComponent('variant').value
        if (!attackstate) return
        if (attackstate) {

            switch (attackstate) {


                case 0:
                    break
            
            
                // Smack
                case 1:
                    if (ShieldTest === 0 && !player.isSneaking) {
                        player.addEffect('wither', 20, {amplifier: 1})
                    }
                    break
    
    
                // Grab
                case 2:
                    if (ShieldTest === 0 && !player.isSneaking) {
                        player.addEffect('wither', 20, {amplifier: 1})
                    }
                    break
    
    
                // Slam
                case 3:
                    const DeathbladeViewVec = deathblade.getViewDirection();
                    player.applyKnockback(DeathbladeViewVec.x, DeathbladeViewVec.z, 4, 0.45)
                    deathblade.runCommandAsync('particle minecraft:knockback_roar_particle ~ ~ ~')
                    break
    
    
                // Horns
                case 4:
                    player.applyKnockback(0, 0, 0, 0.65)
                    if (ShieldTest === 0 && !player.isSneaking) {
                        player.setOnFire(5)
                    }
                    break
            }
        }
        else return
    }





        // Brawlatar
        if (a.typeId === 'darkw_dotvi:brawlatar') {
            const brawlatar = event.damageSource.damagingEntity
            const player = event.hurtEntity
            const BrawlatarViewVec = brawlatar.getViewDirection();
    
            // Get current attack state
            const attackstate = brawlatar.getComponent('variant').value
            if (!attackstate) return
            if (attackstate) {
                switch (attackstate) {
    
                    case 0:
                        break
                
                
                    // Smack
                    case 1:
                        player.applyKnockback(BrawlatarViewVec.x, BrawlatarViewVec.z, 1.5, 0.3)
                        break
        
        
                    // Grab
                    case 2:
                        player.applyKnockback(BrawlatarViewVec.x, BrawlatarViewVec.z, 2.5, 0.3)
                        break
        
        
                    // Slam
                    case 3:
                        player.applyKnockback(BrawlatarViewVec.x, BrawlatarViewVec.z, 3.5, 0.3)
                        break
        
        
                    // Puke
                    case 4:

                        player.addEffect('nausea', 200, {amplifier: 2})
                        player.addEffect('wither', 200, {amplifier: 1})
                        player.applyKnockback(BrawlatarViewVec.x, BrawlatarViewVec.z, 4.5, 0.3)
                        break
                }
            }
            else return
    
    
        }
})