import { world, system, EquipmentSlot } from "@minecraft/server"

class loreItem {
    constructor(itemId, lore) {
        this.itemId = itemId;
        this.lore = lore;
    }
}

const ItemArray = [
    new loreItem("darkw_dotvi:weapon_deathblade", ['\n§r§e+ On Use:', '§r§9Sets off a withering explosion', '§r§4Stops working at low durability', '\nThis ability is subject to change.']),
    new loreItem("darkw_dotvi:weapon_alatar", ['\n§r§e+ When Placed On Block:', '§r§9Summons the selected Alatar rune.', '§r§4(Stops working at low durability)', '\n§r§e+ When Used While Crouching:', '§r§9Selects a new Rune']),
    new loreItem("darkw_dotvi:weapon_brawlatar", ['\n§r§e+ Passive:', '§r§9User becomes sick after enough use', '\n§r§e+ When Used While Sick:', '§r§9Unleashes a Fatal Poison Nova']),
    new loreItem("darkw_dotvi:weapon_eribus", ['\n§r§e+ On Hit While Sneaking:', '§r§9Teleports mobs away from the holder', '\n§r§e+ On Use:', '§r§9Teleports the user forward.', '§r§2The user must have open space in front of them']),
    new loreItem("darkw_dotvi:weapon_puppet", ['\n§r§e+ On Hit:', '§r§9Has a chance to inflict bonus damage', '\n§r§e+ On Use:', '§r§9Shoots a piece of Dark Kunai.', '§r§2Teleports owner on impact.']),
    new loreItem("darkw_dotvi:weapon_yin", ['\n§r§e+ On Hit:', '§r§9Steals life from the victim', '§r§2Damage Dealt repairs the blade', '\n§r§e+ On Crouch:', '§r§9Steals holders health to charge itself up.', '§r§2User will gain particles on full charge.', '\n§r§e+ On Use While Charged:', '§r§9Blade lets off a massive explosion.', '§r§2Requires at least half durability.']),
    new loreItem("darkw_dotvi:alatine_template", ['§r§7Smithing Template\n', '§r§7Applies to:\n§9 Diamond Armor', '§r§7Ingredients:\n §9Netherite Ingot']),
    new loreItem("darkw_dotvi:chaos_helmet", ['\n§r§e+ Set Bonus', '§r§9Applies useful potion effects to the wearer']),
    new loreItem("darkw_dotvi:chaos_chestplate", ['\n§r§e+ Set Bonus', '§r§9Applies useful potion effects to the wearer']),
    new loreItem("darkw_dotvi:chaos_leggings", ['\n§r§e+ Set Bonus', '§r§9Applies useful potion effects to the wearer']),
    new loreItem("darkw_dotvi:chaos_boots", ['\n§r§e+ Set Bonus', '§r§9Applies useful potion effects to the wearer'])
]

system.runInterval(() => { // Lore Controls
    for (const player of world.getPlayers()) { // Gets all players
        const playerContainer = player.getComponent("inventory").container; //
        for (let i = 0; i < playerContainer.size; i++) {
            const item = playerContainer.getItem(i);
            const findLore = ItemArray.find(x => x.itemId == item?.typeId);
            const lore = item?.getLore();
            if (!findLore || !item?.amount || lore?.length != 0) continue;
            item.setLore(findLore.lore);
            playerContainer.setItem(i, item);
        }
    }
}, 1);