import { world, system, ItemStack, EquipmentSlot, EntityComponentTypes, ItemDurabilityComponent } from "@minecraft/server"


world.afterEvents.entityHitEntity.subscribe(event => {
    // If player attacks, do something
    if (!event.damagingEntity) return
    if (event.damagingEntity.typeId === 'minecraft:player') {
        const player = event.damagingEntity
        const equippable = player.getComponent("equippable").getEquipment("Mainhand")
    }

})

world.beforeEvents.worldInitialize.subscribe(event => {
    // Eribus Sword
    event.itemComponentRegistry.registerCustomComponent("darkw_dotvi:weapon_eribus", {
        onUse: e => {
            const player = e.source

            const equipment = player.getComponent('equippable');
            const mainHand = equipment.getEquipment("Mainhand"); 
            let durability = mainHand.getComponent('durability')

            if (!player.isSneaking && durability.damage < 1400) {
                const TeleportTest = player.runCommand('/execute if block ^ ^ ^7 air').successCount
                if (TeleportTest === 1) {
                    player.runCommandAsync('execute as @s if block ^ ^ ^7 air run teleport ^ ^ ^7')
                    player.runCommandAsync('particle darkw_dotvi:teleport ~ ~ ~')
                    player.runCommandAsync('playsound mob.shulker.teleport @s')
                    const gamemode = player.getGameMode()
                    if ((gamemode === 'survival' || gamemode === 'adventure')) {
                        durability.damage += 35
                        equipment.setEquipment("Mainhand", mainHand);
                    }
                }
            }
        },
        onHitEntity: e => {
            const player = e.attackingEntity
            const victim = e.hitEntity

            const equipment = player.getComponent('equippable');
            const mainHand = equipment.getEquipment("Mainhand"); 
            let durability = mainHand.getComponent('durability')

            if (durability.damage < 1400) {

                            // Get Random Number
            const RandomNumber = Math.floor(Math.random() * 4)

            // Teleport In Random Direction
            const gamemode = player.getGameMode()
            if (gamemode === 'survival' || gamemode === 'adventure') {
                durability.damage += 50
                equipment.setEquipment("Mainhand", mainHand);
            }

            if (player.isSneaking) {
                if (RandomNumber === 0) {
                    victim.runCommandAsync('particle darkw_dotvi:teleport ~ ~ ~')
                    victim.runCommandAsync('execute as @s if block ~7 ~ ~ air run teleport ~7 ~ ~')
                    player.runCommandAsync('playsound mob.shulker.teleport @s')
                }
                if (RandomNumber === 1) {
                    victim.runCommandAsync('particle darkw_dotvi:teleport ~ ~ ~')
                    victim.runCommandAsync('execute as @s if block ~ ~ ~7 air run teleport ~ ~ ~7')
                    player.runCommandAsync('playsound mob.shulker.teleport @s')
                }
                if (RandomNumber === 2) {
                    victim.runCommandAsync('particle darkw_dotvi:teleport ~ ~ ~')
                    victim.runCommandAsync('execute as @s if block ~-7 ~ ~ air run teleport ~-7 ~ ~')
                    player.runCommandAsync('playsound mob.shulker.teleport @s')
                }
                if (RandomNumber === 3) {
                    victim.runCommandAsync('particle darkw_dotvi:teleport ~ ~ ~')
                    victim.runCommandAsync('execute as @s if block ~ ~ ~-7 air run teleport ~ ~ ~-7')
                    player.runCommandAsync('playsound mob.shulker.teleport @s')
                }
            }}
        }
    }),
        event.itemComponentRegistry.registerCustomComponent("darkw_dotvi:weapon_alatar", {
            onUse: e => {
                const player = e.source
                const scoreboard = world.scoreboard

                const RuneSelect = scoreboard.getObjective('darkw_dotvi:Alatar_RuneSelection').getScore(player)



                if (player.isSneaking) {

                    // +1 Score
                    player.runCommand('scoreboard players add @s darkw_dotvi:Alatar_RuneSelection 1')


                    switch (RuneSelect) {

                        // None
                        case 0:
                            player.runCommandAsync('title @s actionbar Rune Selected: Clensing Rune')
                            player.playSound('misc.ping')
                            break

                        // Clensing
                        case 1:
                            player.runCommandAsync('title @s actionbar Rune Selected: Explosion Rune')
                            player.playSound('misc.ping')
                            break


                        // Explosion
                        case 2:
                            player.runCommandAsync('title @s actionbar Rune Selected: Voidburn Rune')
                            player.playSound('misc.ping')
                            break


                        // Voidburn
                        case 3:
                            player.runCommandAsync('title @s actionbar No Rune Selected')
                            player.playSound('misc.ping')
                            break
                    }
                }

            },
            "onUseOn": e => {

                // Grabbing variables
                const block = e.block
                const x = e.block.x + 0.5
                const y = e.block.y + 1
                const z = e.block.z + 0.5



                const player = e.source
                const scoreboard = world.scoreboard
                const RuneSelect = scoreboard.getObjective('darkw_dotvi:Alatar_RuneSelection').getScore(player)

                if (!player.isSneaking) {

                    // Get Item
                    const equipment = player.getComponent('equippable');
                    const mainHand = equipment.getEquipment("Mainhand"); 
                    let durability = mainHand.getComponent('durability')

                    if (durability.damage < 1400) {

                        const gamemode = player.getGameMode()
                        if ((gamemode === 'survival' || gamemode === 'adventure') && RuneSelect > 0) {
                            durability.damage += 50
                            equipment.setEquipment("Mainhand", mainHand);
                        }

                        switch (RuneSelect) {

                            // None
                            case 0:
                                break
                                
    
                            // Clensing
                            case 1:
                                e.block.dimension.spawnEntity('darkw_dotvi:alatarrune_clear', { x, y, z })
                                break
    
    
                            // Explosion
                            case 2:
                                e.block.dimension.spawnEntity('darkw_dotvi:alatarrune_escaton', { x, y, z })
                                break
    
    
                            // Voidburn
                            case 3:
                                e.block.dimension.spawnEntity('darkw_dotvi:alatarrune_voidburn', { x, y, z })
                                break
                        }
                    }


                }
            }
        }),
        event.itemComponentRegistry.registerCustomComponent("darkw_dotvi:weapon_brawlatar", {
            onHitEntity: e => {
                const player = e.attackingEntity
                const victim = e.hitEntity
                const PlayerViewVec = player.getViewDirection();

                const TestIsSick = player.runCommand('testfor @s[scores={darkw_dotvi:Brawlatar_WeaponSickness=100..}]').successCount
                if (TestIsSick) {
                    if (!victim) return
                    victim.applyKnockback(PlayerViewVec.x, PlayerViewVec.z, 1.5, 0.3)
                }

                player.runCommandAsync('scoreboard players add @s darkw_dotvi:Brawlatar_WeaponSickness 35')



            },
            onUse: e => {
                const player = e.source
                const TestIsSick = player.runCommand('testfor @s[scores={darkw_dotvi:Brawlatar_WeaponSickness=100..}]').successCount

                if (TestIsSick === 1) {
                    player.runCommandAsync('scoreboard players set @s darkw_dotvi:Brawlatar_WeaponSickness 0')
                    player.runCommandAsync('effect @e[r=7, type=!player] fatal_poison 5 5')
                    player.runCommandAsync('playsound brawlatar.throwup_ui @s')
                    player.runCommandAsync('particle darkw_dotvi:brawlypuke2 ~ ~1 ~')
                }
            }
        }),
        event.itemComponentRegistry.registerCustomComponent("darkw_dotvi:weapon_puppet", {
            onUse: e => {
                const player = e.source
                const item = e.itemStack

                const equipment = player.getComponent('equippable');
                const mainHand = equipment.getEquipment("Mainhand"); 
                let durability = mainHand.getComponent('durability')

                system.run(() => {
                    KunaiShoot(player)

                    const gamemode = player.getGameMode()

                    system.run(() => {
                        if ((gamemode === 'survival' || gamemode === 'adventure')) {
                            durability.damage += 12
                            equipment.setEquipment("Mainhand", mainHand);
                        }
                    })
                })
            },
            onHitEntity: e => {
                
                const player = e.attackingEntity
                const gamemode = e.attackingEntity.getGameMode()

                const equipment = player.getComponent('equippable');
                const mainHand = equipment.getEquipment("Mainhand"); 
                let durability = mainHand.getComponent('durability')

                const RanNum = Math.floor(Math.random() * 3)

                const victim = e.hitEntity

                if (RanNum === 0) {
                    victim.runCommandAsync('playsound misc.thepuppet.zappy @a[r=7] ~~~')
                    victim.runCommandAsync('particle darkw_dotvi:puppetzappy ~~~')
                    victim.applyDamage(40)
                    system.run(() => {
                        if ((gamemode === 'survival' || gamemode === 'adventure')) {
                            durability.damage += 20
                            equipment.setEquipment("Mainhand", mainHand);
                        }
                    })
                }
            }
        })
    event.itemComponentRegistry.registerCustomComponent("darkw_dotvi:weapon_yin", {
        onUse: e => {
            const player = e.source
            const item = e.itemStack

            const gamemode = player.getGameMode()

            const equipment = player.getComponent('equippable');
            const mainHand = equipment.getEquipment("Mainhand"); 
            let durability = mainHand.getComponent('durability')

            const CreationTest = player.runCommand('/testfor @s[scores={darkw_dotvi:CREATIONCAHRGE=100..}]').successCount

            if ((CreationTest === 1 && durability.damage < 1250) || CreationTest === 1 && gamemode === 'creative') {
                player.addEffect('resistance', 15, { amplifier: 50 })
                player.runCommandAsync('summon darkw_dotvi:alatarrune_escaton_yin')
                player.runCommandAsync('scoreboard players set @s darkw_dotvi:CREATIONCAHRGE 0')
                player.runCommandAsync('damage @e[r=15, type=!player, family=!disciple] 45 entity_explosion')
                player.runCommandAsync('effect @e[r=15, type=!player, family=!disciple] wither 5 5')
                player.runCommandAsync('particle darkw_dotvi:yin_one ~ ~ ~')
                player.runCommandAsync('particle darkw_dotvi:yin_two ~ ~ ~')
                player.runCommandAsync('playsound misc.yinboom @a[r=15] ~ ~ ~')


                if ((gamemode === 'survival' || gamemode === 'adventure')) {
                    durability.damage += 1250
                    equipment.setEquipment("Mainhand", mainHand);
                }
            }
        },
        onHitEntity: e => {
            const player = e.attackingEntity
            const victim = e.hitEntity

            const equipment = player.getComponent('equippable');
            const mainHand = equipment.getEquipment("Mainhand"); 
            let durability = mainHand.getComponent('durability')
            if (durability.damage > 150) {
                durability.damage -= 50
            }
            equipment.setEquipment("Mainhand", mainHand);

            player.addEffect('regeneration', 100, { amplifier: 5 })
            victim.addEffect('wither', 100, { amplifier: 5 })

        }
    }),
    event.itemComponentRegistry.registerCustomComponent("darkw_dotvi:weapon_deathblade", {
        onHitEntity: e => {
            const player = e.attackingEntity
            const victim = e.hitEntity

            victim.addEffect('wither', 100, {amplifier: 2})
        },
        onUse: e => {
            const player = e.source

            const equipment = player.getComponent('equippable');
            const mainHand = equipment.getEquipment("Mainhand"); 
            let durability = mainHand.getComponent('durability')

            if (durability.damage < 1450) {
                // set

                const gamemode = player.getGameMode()
                if (gamemode === 'survival' || gamemode === 'adventure') {
                    durability.damage += 150
                }
                player.runCommandAsync('/execute as @e[r=5, type=!player] run scriptevent darkw_dotvi:deathblade_sword_victim')
                player.setOnFire(5)
                player.runCommandAsync('playsound deathblade.flame_player @s ~ ~ ~')
                player.runCommandAsync('particle darkw_dotvi:deathyslam1 ~ ~ ~')
                player.runCommandAsync('particle darkw_dotvi:deathyslam2 ~ ~ ~')
                player.applyDamage(6)

                // set back to the inventory
                equipment.setEquipment("Mainhand", mainHand);
                }
            else {
                player.runCommandAsync('/particle minecraft:cauldron_explosion_emitter ~ ~ ~')
                player.runCommandAsync('/playsound random.fizz_ui @s')
            }
        }
    })
})


function KunaiShoot(player) {
    const playerViewDirection = player.getViewDirection();
    const velocityMultiplier = 5.0;

    const projectile = player.dimension.spawnEntity("darkw_dotvi:dark_kunai", {
        x: player.location.x + playerViewDirection.x,
        y: player.location.y + 1 + playerViewDirection.y,
        z: player.location.z + playerViewDirection.z,
    });

    const projectileComponent = projectile.getComponent(EntityComponentTypes.Projectile);
    const { x: vx, y: vy, z: vz } = player.getViewDirection();

    projectileComponent.shoot({
        x: vx * velocityMultiplier,
        y: vy * velocityMultiplier,
        z: vz * velocityMultiplier
    });
    projectileComponent.owner = player;
}


world.afterEvents.entityHurt.subscribe(event => {

    if (!event.damageSource.damagingEntity) return
    if (!event.damageSource.damagingProjectile) return
    if (!event.damageSource.cause) return

    if (event.damageSource.damagingEntity.typeId === 'minecraft:player') {
        const player = event.damageSource.damagingEntity

        const equipment = player.getComponent('equippable');
        const mainHand = equipment.getEquipment("Mainhand"); 
        let durability = mainHand.getComponent('durability')

        if (mainHand.typeId === 'darkw_dotvi:weapon_yin') {
            console.run(() => {
                durability.damage += 50
                equipment.setEquipment("Mainhand", mainHand);
            })
        }


    }
    
})